/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.dao.database.factory;

import uk.ac.roslin.ensembl.dao.database.DBSpecies;
import uk.ac.roslin.ensembl.dao.factory.DAOSpeciesFactory;
import uk.ac.roslin.ensembl.exception.DAOException;
import uk.ac.roslin.ensembl.model.core.CollectionSpecies;
import uk.ac.roslin.ensembl.model.core.Species;
import uk.ac.roslin.ensembl.model.database.CollectionDatabase;
import uk.ac.roslin.ensembl.model.database.SingleSpeciesDatabase;

/**
 *
 * @author tpaterso
 */
public abstract class DBDAOSpeciesFactory extends DBDAOFactory implements DAOSpeciesFactory{

    protected DBSpecies species = null;

    public DBDAOSpeciesFactory()   {
        super();
    }


    public DBDAOSpeciesFactory(SingleSpeciesDatabase database)  throws DAOException {
        super(database);
        this.species = (DBSpecies) database.getSpecies();

    }

    public DBDAOSpeciesFactory(CollectionDatabase database, CollectionSpecies species)  throws DAOException {
        this();
        super.setDatabase(database);
        this.species = (DBSpecies) species;
    }

    @Override
    public DBSpecies getSpecies() {
        return this.species;
    }

    @Override
    public void setSpecies(Species species) {
        this.species = (DBSpecies) species;
    }


}
