/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.dao.factory;

import uk.ac.roslin.ensembl.config.EnsemblComparaDivision;
import uk.ac.roslin.ensembl.dao.coreaccess.ChromosomeDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.GeneDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.ProteinFeatureDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.AssemblyDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.CoordinateSystemDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.DNASequenceDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.ExonDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.TranscriptDAO;
import uk.ac.roslin.ensembl.dao.coreaccess.TranslationDAO;
import uk.ac.roslin.ensembl.exception.DAOException;

public interface DAOCoreFactory extends DAOFactory  {

    public GeneDAO getGeneDAO() throws DAOException;
    public ProteinFeatureDAO getProteinFeatureDAO() throws DAOException;
    public ChromosomeDAO getChromosomeDAO() throws DAOException;
    public CoordinateSystemDAO getCoordinateSystemDAO() throws DAOException;
    public AssemblyDAO getAssemblyDAO() throws DAOException;
    public DNASequenceDAO getSequenceDAO() throws DAOException;
    public TranslationDAO getTranslationDAO() throws DAOException;
    public TranscriptDAO getTranscriptDAO()  throws DAOException;
    public ExonDAO getExonDAO()  throws DAOException;
    public DAOComparaFactory getComparaFactory(EnsemblComparaDivision comparaDivision);



}
