/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.dao.factory;

import java.util.Properties;
import org.apache.ibatis.session.SqlSession;
import uk.ac.roslin.ensembl.exception.DAOException;
import uk.ac.roslin.ensembl.model.database.Database;
import uk.ac.roslin.ensembl.model.database.DatabaseType;
import uk.ac.roslin.ensembl.model.database.Registry;

public interface DAOFactory {

    public void setDBType(DatabaseType type);
    public DatabaseType getDBType();

    public Registry getRegistry();
    
    public Properties getConfiguration();
    
    public void setMybatisSchemaFilePath(String schema);
    public String getMybatisSchemaFilePath();

    public void setEnsemblSchemaVersion(String schemaVersion);
    public String getEnsemblSchemaVersion();

    public void setDBVersion(String dbversion);
    public String getDBVersion() ;

    public void setDatabaseName(String full_db_name);
    public String getDatabaseName();

    public Database getDatabase() ;

    public SqlSession getNewSqlSession() throws DAOException;

}
