/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.datasourceaware;

import uk.ac.roslin.ensembl.model.ExternalDB;
import uk.ac.roslin.ensembl.model.ObjectType;
import uk.ac.roslin.ensembl.config.EnsemblCoreObjectType;

/**
 *
 * @author tpaterso
 */
public class DAExternalDB extends DAObject implements ExternalDB {

    String dBName = null;
    String dBDisplayName = null ;
    String dBRelease = null;
    String dBStatus = null;
    String dBType = null;

    public String getDBDisplayName() {
        return dBDisplayName;
    }

    public void setDBDisplayName(String dBDisplayName) {
        this.dBDisplayName = dBDisplayName;
    }

    public String getDBName() {
        return dBName;
    }

    public void setDBName(String dBName) {
        this.dBName = dBName;
    }

    public String getDBRelease() {
        return dBRelease;
    }

    public void setDBRelease(String dBRelease) {
        this.dBRelease = dBRelease;
    }

    public String getDBStatus() {
        return dBStatus;
    }

    public void setDBStatus(String dBStatus) {
        this.dBStatus = dBStatus;
    }

    public String getDBType() {
        return dBType;
    }

    public void setDBType(String dBType) {
        this.dBType = dBType;
    }

    public ObjectType getType() {
        return EnsemblCoreObjectType.externalDB;
    }


}
