/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */
package uk.ac.roslin.ensembl.datasourceaware.compara;

import java.util.ArrayList;
import java.util.List;
import java.util.TreeSet;
import uk.ac.roslin.ensembl.dao.factory.DAOComparaFactory;
import uk.ac.roslin.ensembl.datasourceaware.DAObject;
import uk.ac.roslin.ensembl.datasourceaware.core.DAGene;
import uk.ac.roslin.ensembl.model.compara.HomologyRelationship;
import uk.ac.roslin.ensembl.model.compara.HomologyType;
import uk.ac.roslin.ensembl.model.core.Species;
import uk.ac.roslin.ensembl.model.relationship.RelationshipType;


public  class DAHomologyRelationship extends DAObject implements HomologyRelationship<DAGene> {

    public DAHomologyRelationship() {
        super();
    }

//    public DAHomologyRelationship(DAOComparaFactory factory) {
//        //super(factory);
//    }

    private HomologyType type = null;
    private String lastCommonAncestor = "";
    private TreeSet<DAGene> members = new TreeSet<DAGene>(DAObject.daComparator);

    public TreeSet<DAGene> getMembers() {
        return members;
    }

    public HomologyType getType() {
        return this.type;
    }

    public void setType(HomologyType type) {
        this.type = type;
    }

    public String getLastCommonAncestor() {
        return this.lastCommonAncestor;
    }

    public List<Species> getSpecies() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void setLastCommonAncestor(String lastCommonAncestor) {
        this.lastCommonAncestor = lastCommonAncestor;
    }

    public HomologyType getRelationshipType() {
        return this.type;
    }

    public void setRelationshipType(RelationshipType type) {
        this.type = (HomologyType) type;
    }
}
