/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.datasourceaware.core;

import uk.ac.roslin.ensembl.dao.factory.DAOCoreFactory;
import uk.ac.roslin.ensembl.model.ObjectType;
import uk.ac.roslin.ensembl.model.core.ProteinFeature;

public class DAProteinFeature extends DACoreObject implements ProteinFeature {

    private int translationID;
    private int sourceStart;
    private int sourceEnd;
    private String targetName;
    private int targetStart;
    private int targetEnd;
    private int analysisID;
    private Double score;
    private Double eValue;
    private Double percentIdentity;


    public DAProteinFeature() {
    }

    public DAProteinFeature(DAOCoreFactory factory) {
        super.setDaoFactory(factory);
    }

    public int getAnalysisID() {
        return analysisID;
    }

    public void setAnalysisID(int analysisID) {
        this.analysisID = analysisID;
    }

    public Double getEValue() {
        return eValue;
    }

    public void setEValue(Double eValue) {
        this.eValue = eValue;
    }

    public Double getPercentIdentity() {
        return percentIdentity;
    }

    public void setPercentIdentity(Double percentIdentity) {
        this.percentIdentity = percentIdentity;
    }

    public Double getScore() {
        return score;
    }

    public void setScore(Double score) {
        this.score = score;
    }

    public int getSourceEnd() {
        return sourceEnd;
    }

    public void setSourceEnd(int sourceEnd) {
        this.sourceEnd = sourceEnd;
    }

    public int getSourceStart() {
        return sourceStart;
    }

    public void setSourceStart(int sourceStart) {
        this.sourceStart = sourceStart;
    }

    public int getTargetEnd() {
        return targetEnd;
    }

    public void setTargetEnd(int targetEnd) {
        this.targetEnd = targetEnd;
    }

    public String getTargetName() {
        return targetName;
    }

    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }

    public int getTargetStart() {
        return targetStart;
    }

    public void setTargetStart(int targetStart) {
        this.targetStart = targetStart;
    }

    public int getTranslationID() {
        return translationID;
    }

    public void setTranslationID(int translationID) {
        this.translationID = translationID;
    }

    public ObjectType getType() {
        return null;
    }
}
