/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.datasourceaware.core;

import java.util.ArrayList;
import java.util.List;
import org.apache.log4j.Logger;
import uk.ac.roslin.ensembl.config.EnsemblCoreObjectType;
import uk.ac.roslin.ensembl.exception.DAOException;
import uk.ac.roslin.ensembl.model.ObjectType;
import uk.ac.roslin.ensembl.model.core.ProteinFeature;
import uk.ac.roslin.ensembl.model.core.Translation;

/**
 *
 * @author tpaterso
 */
//just a demo class - very simplistic implementation
public class DATranslation extends DACoreObject implements Translation {

    DATranscript transcript = null;
    List<? extends ProteinFeature> proteinFeatures = null;
    final static Logger LOGGER = Logger.getLogger(DATranslation.class);

    public List<? extends ProteinFeature> getProteinFeatures() {
        if (proteinFeatures == null) {

            if (this.getId()==null) {
                return null;
            }

            try {
                proteinFeatures = this.getDaoFactory().getProteinFeatureDAO().getProteinFeaturesByTranslationID(this.id);
            } catch (DAOException dex) {
                LOGGER.info("failed to get Protein Features", dex);
            } catch (Exception ex) {
                LOGGER.info("failed to get Protein Features", ex);
            }
 
        }
        return proteinFeatures;
    }

    public DATranscript getTranscript() {
        return transcript;
    }

    public void setTranscript(DATranscript transcript) {
        this.transcript = transcript;
    }

    public ObjectType getType() {
        return EnsemblCoreObjectType.translation;
    }

}
