/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.mapper.query;

/**
 *
 * @author tpaterso
 */
public class FeatureQuery {

    protected Integer featureID = null;
    protected Integer geneID = null;
    protected Integer transcriptID = null;
    protected Integer speciesID = null;
    protected String  featureStableID = null;
    protected Integer parentSequenceID = null;
    protected Integer parentStart = null;
    protected Integer parentStop = null;
    protected Integer coordinateSystemID = null;
    protected Integer maximumFeatureLength = null;

    /**
     * Get the value of featureID
     *
     * @return the value of featureID
     */
    public Integer getFeatureID() {
        return featureID;
    }

    /**
     * Set the value of featureID
     *
     * @param featureID new value of featureID
     */
    public void setFeatureID(Integer featureID) {
        this.featureID = featureID;
    }
    /**
     * Get the value of geneID
     *
     * @return the value of geneID
     */
    public Integer getGeneID() {
        return geneID;
    }

    /**
     * Set the value of geneID
     *
     * @param geneID new value of geneID
     */
    public void setGeneID(Integer geneID) {
        this.geneID = geneID;
    }
    /**
     * Get the value of transcriptID
     *
     * @return the value of transcriptID
     */
    public Integer getTranscriptID() {
        return transcriptID;
    }

    /**
     * Set the value of transcriptID
     *
     * @param transcriptID new value of transcriptID
     */
    public void setTranscriptID(Integer transcriptID) {
        this.transcriptID = transcriptID;
    }

    /**
     * Get the value of featureStableID
     *
     * @return the value of featureStableID
     */
    public String getFeatureStableID() {
        return featureStableID;
    }

    /**
     * Set the value of featureStableID
     *
     * @param featureStableID new value of featureStableID
     */
    public void setFeatureStableID(String featureStableID) {
        this.featureStableID = featureStableID;
    }


    /**
     * Get the value of parentSequenceID
     *
     * @return the value of parentSequenceID
     */
    public Integer getParentSequenceID() {
        return parentSequenceID;
    }

    /**
     * Set the value of parentSequenceID
     *
     * @param parentSequenceID new value of parentSequenceID
     */
    public void setParentSequenceID(Integer parentSequenceID) {
        this.parentSequenceID = parentSequenceID;
    }

    public Integer getCoordinateSystemID() {
        return coordinateSystemID;
    }

    public void setCoordinateSystemID(Integer cordinateSystemID) {
        this.coordinateSystemID = cordinateSystemID;
    }

    public Integer getMaximumFeatureLength() {
        return maximumFeatureLength;
    }

    public void setMaximumFeatureLength(Integer maximumFeatureLength) {
        this.maximumFeatureLength = maximumFeatureLength;
    }

    public Integer getParentStart() {
        return parentStart;
    }

    public void setParentStart(Integer start) {
        this.parentStart = start;
    }

    public Integer getParentStop() {
        return parentStop;
    }

    public void setParentStop(Integer stop) {
        this.parentStop = stop;
    }

    public Integer getSpeciesID() {
        return speciesID;
    }

    public void setSpeciesID(Integer speciesID) {
        this.speciesID = speciesID;
    }

}
