/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */
package uk.ac.roslin.ensembl.model.compara;

import java.util.List;
import uk.ac.roslin.ensembl.model.core.Gene;
import uk.ac.roslin.ensembl.model.core.Species;
import uk.ac.roslin.ensembl.model.relationship.GroupRelationship;


/**
 * Ensembl schema and PerlAPI claims that homology relationships
 * are not necessarily only binary, i.e. the could have more than two members.
 */
public interface HomologyRelationship<CLAZZ extends Gene> extends GroupRelationship<CLAZZ> {

    @Override
    public HomologyType getRelationshipType();

    public String getLastCommonAncestor();

    public List<? extends Species> getSpecies();


}
