/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.model.core;

import java.util.Collection;
import java.util.HashMap;
import java.util.TreeSet;
import uk.ac.roslin.ensembl.model.database.CollectionDatabase;
import uk.ac.roslin.ensembl.model.database.DatabaseType;

/**
 *
 * @author paterson
 */
public interface CollectionOfSpecies {

    public void setProperty(String id, HashMap row) ;

    public String getDBVersion() ;

    public String getCollectionName() ;

    public CollectionDatabase getCoreDatabase();

    public String getSchemaVersion() ;

    public TreeSet<? extends CollectionDatabase> getDatabases() ;

    public void addDatabases(TreeSet<? extends CollectionDatabase> databases) ;

    public TreeSet<? extends CollectionSpecies> getSpecies() ;

    public void addSpecies(Collection<? extends CollectionSpecies> spp);

    public void addSpecies(CollectionSpecies sp) ;

    public TreeSet<? extends CollectionDatabase> getDatabasesByType(DatabaseType type) ;

}
