/**
 * Copyright (C) 2011 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */
package uk.ac.roslin.ensembl.model.core;

/**
 *
 * @author tpaterso
 */
public interface Exon extends Feature {

   public static class Phase {
        public static int ZERO = 0;
        public static int ONE = 1;
        public static int TWO = 2;
        public static int NONE = -1;

        public static int getPhase(int p) {
            if (p==0) {
                return ZERO;
            }
            else if (p==1) {
                return ONE;
            }
            else if (p==2) {
                return TWO;
            }
            else return NONE;
        }
    }



    public int getPhase() ;

    public Boolean isConstitutive() ;

}
