/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */

package uk.ac.roslin.ensembl.model.core;

public interface ProteinFeature {

    public int getAnalysisID();

    public void setAnalysisID(int analysisID);

    public Double getEValue();

    public void setEValue(Double eValue);

    public Double getPercentIdentity();

    public void setPercentIdentity(Double percentIdentity) ;

    public Double getScore();

    public void setScore(Double score) ;

    public int getSourceEnd();

    public void setSourceEnd(int sourceEnd);

    public int getSourceStart();

    public void setSourceStart(int sourceStart);

    public int getTargetEnd();

    public void setTargetEnd(int targetEnd);

    public String getTargetName();

    public void setTargetName(String targetName);

    public int getTargetStart();

    public void setTargetStart(int targetStart);

    public int getTranslationID();

    public void setTranslationID(int translationID);

}
