/**
 * Copyright (C) 2010 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */
package uk.ac.roslin.ensembl.test;


import org.apache.log4j.PropertyConfigurator;
import uk.ac.roslin.ensembl.config.DBConnection.DataSource;
import uk.ac.roslin.ensembl.config.EnsemblDBType;
import uk.ac.roslin.ensembl.config.FeatureType;
import uk.ac.roslin.ensembl.dao.database.DBCollectionCoreDatabase;
import uk.ac.roslin.ensembl.dao.database.DBDatabase;
import uk.ac.roslin.ensembl.dao.database.DBRegistry;
import uk.ac.roslin.ensembl.dao.database.DBSingleSpeciesCoreDatabase;
import uk.ac.roslin.ensembl.dao.database.DBSpecies;


public class QuickTest3 {

    public static void main(String[] args) throws Exception {

        PropertyConfigurator.configure("log4j.properties");

        //Registry eReg = DBRegistryFactory.createDefaultRegistry(DataSource.ENSEMBLDB);
        //Registry eReg = new DBRegistry(new RegistryConfiguration(DataSource.ENSEMBLDB));
        DBRegistry eReg = new DBRegistry(DataSource.ENSEMBLDB);

        System.out.println("Build level gene vs transcript");

        for (DBDatabase d :eReg.getDatabasesByType(EnsemblDBType.core)) {

            DBSingleSpeciesCoreDatabase db = (DBSingleSpeciesCoreDatabase) d;

            System.out.println(db.getdBName() + "\t\t\t"
                    +db.getBuildLevel(FeatureType.gene.toString()) + " "
                    +db.getBuildLevel(FeatureType.transcript.toString()) + " ");

        }

        System.out.println("NUMBER OF CS for gene vs transcript");

         for (DBDatabase d :eReg.getDatabasesByType(EnsemblDBType.core)) {

            DBSingleSpeciesCoreDatabase db = (DBSingleSpeciesCoreDatabase) d;

            System.out.println(db.getdBName() + "\t\t\t"
                     +db.getCSForFeature(FeatureType.gene).size() + " "
                     +db.getCSForFeature(FeatureType.transcript).size()
                    );
         }

         eReg = new DBRegistry(DataSource.ENSEMBLGENOMES);

        System.out.println("Build level gene vs transcript - ss");

        for (DBDatabase d :eReg.getDatabasesByType(EnsemblDBType.core)) {

            DBSingleSpeciesCoreDatabase db = (DBSingleSpeciesCoreDatabase) d;

            System.out.println(db.getdBName() + "\t\t\t"
                    +db.getBuildLevel(FeatureType.gene.toString()) + " "
                    +db.getBuildLevel(FeatureType.transcript.toString()) + " ");

        }

        System.out.println("NUMBER OF CS for gene vs transcript");

         for (DBDatabase d :eReg.getDatabasesByType(EnsemblDBType.core)) {

            DBSingleSpeciesCoreDatabase db = (DBSingleSpeciesCoreDatabase) d;

            System.out.println(db.getdBName() + "\t\t\t"
                     +db.getCSForFeature(FeatureType.gene).size() + " "
                     +db.getCSForFeature(FeatureType.transcript).size()
                    );
         }

       System.out.println("Build level gene vs transcript - cs");

        for (DBDatabase d :eReg.getDatabasesByType(EnsemblDBType.collection_core)) {

            DBCollectionCoreDatabase db = (DBCollectionCoreDatabase) d;
            
            for (DBSpecies sp : db.getCollection().getSpecies()) {

            System.out.println(db.getdBName() + " " +sp.getDatabaseStyleName()+"\t\t\t"
                    +db.getBuildLevel(sp, FeatureType.gene.toString()) + " "
                    +db.getBuildLevel(sp, FeatureType.transcript.toString()) + " ");
            }
        }

       System.out.println("NUMBER OF CS for gene vs transcript - cs");

        for (DBDatabase d :eReg.getDatabasesByType(EnsemblDBType.collection_core)) {

            DBCollectionCoreDatabase db = (DBCollectionCoreDatabase) d;

            for (DBSpecies sp : db.getCollection().getSpecies()) {

            System.out.println(db.getdBName() + " " +sp.getDatabaseStyleName()+"\t\t\t"
                     +db.getCSForFeature(sp,FeatureType.gene).size() + " "
                     +db.getCSForFeature(sp, FeatureType.transcript).size()
                    + " ");
            }
        }


    }
}
