/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uk.ac.roslin.ensembl.test;

import org.apache.log4j.PropertyConfigurator;
import org.biojava3.core.sequence.Strand;
import uk.ac.roslin.ensembl.config.DBConnection.DataSource;
import uk.ac.roslin.ensembl.dao.database.DBRegistry;
import uk.ac.roslin.ensembl.dao.database.DBSpecies;
import uk.ac.roslin.ensembl.datasourceaware.core.DAChromosome;
import uk.ac.roslin.ensembl.datasourceaware.core.DADNASequence;
import uk.ac.roslin.ensembl.model.Coordinate;
import uk.ac.roslin.ensembl.model.Mapping;

/**
 *
 * @author tpaterso
 */
public class TestDNASeq2 {

    public static void main(String[] args) throws Exception {

         PropertyConfigurator.configure("log4j.properties");

        DBRegistry ensembldbRegistry = new DBRegistry(DataSource.ENSEMBLDB);
        DBSpecies sp = ensembldbRegistry.getSpeciesByAlias("chicken");
        DAChromosome chr = sp.getChromosomeByName("25");
        DAChromosome chr_55 = sp.getChromosomeByName("25", "55");
        
        System.out.println(chr_55.getSequenceAsString(1000, 1020));


        for (Mapping mapping : chr.getCompleteAssembly().getStitchedMappings(1, 3000)) {

            System.out.println(((DADNASequence) mapping.getTarget()).getName()
                    + " : " + mapping.getTargetCoordinates().getStart()
                    + " - " + mapping.getTargetCoordinates().getEnd()
                    + " " + (mapping.getTargetCoordinates().getStrand() == Coordinate.Strand.REVERSE_STRAND ? "reverse" : "")
                    + " (source: " + mapping.getSourceCoordinates().getStart()
                    + " - " + mapping.getSourceCoordinates().getEnd()
                    + ")");
            try {
                System.out.println("mapped sequence length: " + ((DADNASequence) mapping.getTarget()).getDBSeqLength());
                System.out.println("mapped sequence start: " + ((DADNASequence) mapping.getTarget()).getBioBegin());
                System.out.println("mapped sequence end: " + ((DADNASequence) mapping.getTarget()).getBioEnd());
                System.out.println("mapped sequence fullseq length: " + ((DADNASequence) mapping.getTarget()).getSequenceAsString().length());
                System.out.println("mapped sequence fullseq:\n " + ((DADNASequence) mapping.getTarget()).getSequenceAsString());

                if (mapping.getTargetCoordinates().getStrand() == Coordinate.Strand.FORWARD_STRAND) {

                    System.out.println("mapped sequence desired (+) fragment from object:\n "
                            + ((DADNASequence) mapping.getTarget()).getSubSequence(mapping.getTargetCoordinates().getStart(),
                            mapping.getTargetCoordinates().getEnd()).getSequenceAsString());

                    System.out.println("mapped sequence desired (+) fragment from String :\n "
                            + ((DADNASequence) mapping.getTarget()).getSequenceAsString(mapping.getTargetCoordinates().getStart(),
                            mapping.getTargetCoordinates().getEnd(), Strand.POSITIVE));
                } else {

                    System.out.println("mapped sequence desired (-) fragment from String :\n "
                            + ((DADNASequence) mapping.getTarget()).getReverseComplementSequenceAsString(mapping.getTargetCoordinates().getStart(),
                            mapping.getTargetCoordinates().getEnd()));

                }
                System.out.println("");
                //System.out.println(((DASequenceOLD) mapping.getTarget()).getSequenceAsString());





            } catch (Exception e) {
            }


        }

                    System.out.println("chromosome sequence 1-3000\n"
                    + chr.getSequenceAsString(1, 3000));

            System.out.println("chromosome sequence 1-50\n"
                    + chr.getSequenceAsString(1, 50));

            System.out.println("chromosome sequence 1750-1800\n"
                    + chr.getSequenceAsString(1750, 1800));

            System.out.println("chromosome RC sequence 1-3000\n"
                    + chr.getReverseComplementSequenceAsString(1, 3000));

            System.out.println("chromosome RC sequence 1-50\n"
                    + chr.getReverseComplementSequenceAsString(1, 50));

            System.out.println("chromosome RC sequence 1750-1800\n"
                    + chr.getReverseComplementSequenceAsString(1750, 1800));

            System.out.println("\n\n*****************************\n* COMPLETED FUNCTIONAL TEST *\n*****************************\n");

    }
}


