/**
 * Copyright (C) 2011 The Roslin Institute <contact andy.law@roslin.ed.ac.uk>
 *
 * This file is part of the Ensembl Java API demonstration project developed by the
 * Bioinformatics Group at The Roslin Institute, The Royal (Dick) School of
 * Veterinary Studies, University of Edinburgh.
 *
 * This is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (version 3) as published by
 * the Free Software Foundation.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * in this software distribution. If not, see <http://www.gnu.org/licenses/gpl-3.0.html/>.
 */
package uk.ac.roslin.ensembl.test;


import java.io.File;
import org.apache.log4j.PropertyConfigurator;
import uk.ac.roslin.ensembl.config.DBConnection.DataSource;
import uk.ac.roslin.ensembl.config.RegistryConfiguration;
import uk.ac.roslin.ensembl.dao.database.DBRegistry;



public class TestNewConfig {

    public static void main(String[] args) throws Exception {

        PropertyConfigurator.configure("log4j.properties");

        String mappingFilePath = "src/main/resources/test_new_mappings.properties";
        String dbConfigFilePath = "src/main/resources/example_genomes_config.properties";

        if (args != null && args.length==1) {
            mappingFilePath = args[0];
        }
        if (args != null && args.length==2) {
            mappingFilePath = args[0];
            dbConfigFilePath = args[1];
        }

        PropertyConfigurator.configure("log4j.properties");
        File fileM = new File(mappingFilePath);
        File fileC = new File(dbConfigFilePath);

        RegistryConfiguration conf = new RegistryConfiguration(DataSource.ENSEMBLDB);
        conf.setSchemaByFile(fileM);

        //DBRegistry eReg = new DBRegistry(conf,true);
        //System.out.println(eReg.printRegistryReport());

        conf = new RegistryConfiguration(DataSource.ENSEMBLGENOMES);
        conf.setSchemaByFile(fileM);

        conf = new RegistryConfiguration();
        conf.setDBByFile(fileC);
        conf.setSchemaByFile(fileM);
        

        DBRegistry eReg = new DBRegistry(conf,true);

        System.out.println(eReg.printRegistryReport());


    }
}
